UPDATE-ALTERNATIVES(8)

NOMBRE
update-alternatives - mantiene enlaces simbólicos que determinan órdenes predeterminadas.

SINOPSIS
update-alternatives [opciones] --install enlace nombre camino prioridad [--slave enlace nombre camino]...

update-alternatives [opciones] --remove nombre camino

update-alternatives [opciones]
 .B --remove-all nombre

update-alternatives [opciones] --all

update-alternatives [opciones] --auto nombre

update-alternatives [opciones] --display nombre

update-alternatives [opciones] --list nombre

update-alternatives [opciones] --config nombre

update-alternatives [opciones] --set nombre camino

DESCRIPCIÓN
update-alternatives crea, destruye, mantiene y muestra información acerca de los enlaces simbólicos que conforman el sistema de alternativas de Debian.

Es posible que varios programas que realizan la misma función o una parecida estén instalados en el sistema al mismo tiempo. Por ejemplo, muchos sistemas tienen varios editores de texto instalados al mismo tiempo, esto deja la elección de que editor de texto usar en manos del usuario, si éste lo desea, pero hace difícil que un programa elija la opción correcta si el usuario no ha especificado ninguna preferencia.

El objetivo del sistema de alternativas de Debian es resolver este problema. Un nombre genérico en el sistema de ficheros se comparte entre todos los ficheros que tienen una funcionalidad intercambiable. El sistema de alternativas junto con el administrador del sistema determinan a qué fichero hace referencia este nombre genérico. Por ejemplo, si los editores de texto ed(1) y nvi(1) están instalados conjuntamente en el sistema, el sistema de alternativas hará que el nombre genérico /usr/bin/editor se refiera a /usr/bin/nvi . El administrador del sistema puede modificar esto y hacer que se prefiera /usr/bin/ed , el sistema de alternativas no modificará esto posteriormente hasta que se solicite explícitamente.

El nombre genérico no es un enlace directo a la alternativa seleccionada. En vez de esto, es un enlace simbólico a un nombre en el directorio de alternativas , que a su vez en un enlace simbólico al fichero al que se quiere hacer referencia. Esto se hace de este modo para que los cambios del administrador se mantengan dentro del directorio /etc : el FHS (q.v.) da razones de por qué esto es bueno.

Cuando se instala o desinstala un paquete que provee un fichero con una funcionalidad en particular, se llama a update-alternatives para actualizar la información del sistema de alternativas acerca de ese fichero. update-alternatives se llama normalmente desde los scripts postinst o prerm de los paquetes de Debian.

Normalmente es útil para un número de alternativas que estas sean sincronizadas de tal modo que puedan cambiarse como un grupo. Por ejemplo, cuando varias versiones del editor vi(1) están instaladas, la página del manual preferida por /usr/share/man/man1/vi.1 debe de corresponder con el ejecutable al que hace referencia /usr/bin/vi. update-alternatives maneja esto en términos de enlaces maestro y esclavo , cuando se cambia el maestro, todos los esclavos relacionados con él también se cambian. Un enlace maestro y sus esclavos relacionados forman un grupo de enlaces .

Cada grupo de enlaces está en cualquier momento en uno de los dos modos posibles: automático o manual. Cuando un grupo está en modo automático, el sistema de alternativas decide automáticamente a medida que se instalan o desinstalan paquetes cuándo se deben de actualizar los enlaces. En modo manual el sistema de alternativas deja todas estas decisiones en manos del administrador del sistema.

Los grupos de enlaces se establecen en modo automático la primera vez que entran en el sistema. Si el administrador del sistema hace cambios en la configuración automática del sistema, update-alternatives se dará cuenta la próxima vez que se ejecute sobre el grupo de enlaces cambiados, y el grupo será cambiado automáticamente a modo manual.

Cada alternativa tiene una prioridad asociada. Cuando un grupo de enlaces se encuentra en modo automático, la alternativa a la que apuntan los miembros del grupo será la que tenga una prioridad más alta.

Cuando se use la opción --config , update-alternatives mostrará todas las posibilidades para el grupo de enlaces que tienen como maestro a nombre . Entonces se elegirá una de las opciones posibles del grupo de enlaces. Una vez que se haga algún cambio, el grupo de enlaces dejará de estar en modo automático . Será necesario usar la opción --auto para volver el grupo de enlaces al estado automático.

Si quiere realizar la configuración de un modo no interactivo puede usar la opción --set en su lugar (vea más abajo).

TERMINOLOGÍA
Debido a que las actividades que realiza update-alternatives están fuertemente relacionadas entre sí, la definición de algunos términos específicos ayudará a entender su funcionamiento.

nombre genérico
    Un nombre, como /usr/bin/editor, que mediante el sistema de alternativas hace referencia a uno de los posibles ficheros con una función similar.

enlace
    Sólo es un enlace simbólico en el directorio de alternativas, no tiene ningún significado especial. Puede ser ajustado por el administrador.

alternativa
    El nombre específico de un fichero en el sistema de ficheros, que, puede ser accesible a través de un nombre genérico usando el sistema de alternativas.

directorio de alternativas
    El directorio que contiene los enlaces, por omisión es /etc/alternatives.

directorio administrativo
    El directorio que contiene la información de estado de update-alternatives por omisión es /var/lib/dpkg/alternatives.

grupo de enlaces
    Un conjunto de enlaces relacionados, que se pretende que sean actualizados como un grupo.

enlace maestro
    El enlace del grupo de enlaces que determina cómo se configuran el resto de los enlaces del grupo.

enlace esclavo
    Un enlace del grupo de enlaces controlado por el enlace maestro del grupo.

modo automático Cuando un grupo de enlaces se encuentra en modo automático, el
    sistema de alternativas asegura que los enlaces del grupo apuntan a la alternativa con mayor prioridad para ese grupo.

modo manual
    Cuando un grupo de enlaces se encuentra en modo manual, el sistema de alternativas no hará ningún cambio en la configuración del administrador.

EJEMPLOS
Hay varios paquetes que proporcionan un editor de texto compatible con vi, por ejemplo nviy vim. Cual se usa es controlado por el grupo de enlaces vi, que incluye enlaces para el programa y la página del manual asociada.

Para mostrar los paquetes disponibles que proporcionen vi y su actual configuración, use opción --display:

    update-alternatives --display vi

Para elegir una implementación de vi en particular, use la siguiente orden como superusuario y luego seleccione un número de la lista:

    update-alternatives --config vi

Para que la implementación de vi se vuelva a elegir de forma automática, como superusuario haga:

    update-alternatives --auto vi

OPCIONES
Se debe de especificar exactamente una acción a realizar a update-alternatives si se desea que realice algún trabajo significativo. Se puede especificar cualquier número de las opciones comunes junto con cualquier acción.

  OPCIONES COMUNES

--verbose
    Genera una salida con más información acerca de lo que update-alternatives está haciendo.

--quiet
    No genera ningún comentario a menos que ocurra algún error. Esta opción todavía no esta implementada.

--test
    No hace nada realmente, sólo mostrar lo que hubiese hecho. Esta opción todavía no esta implementada.

--help
    Muestra alguna información relativa al modo de uso (y muestra la versión de update-alternatives ).

--version
    Muestra la versión de update-alternatives (y alguna información relativa a su uso).

--altdir directorio
    Especifica el directorio de alternativas cuando va a ser diferente del directorio por omisión.

--admindir directorio
    Especifica el directorio administrativo cuando va a ser diferente del directorio por omisión.

  ACCIONES

--install gen enlace alt pri [--slave sgen senlace salt] ...
    Añade un grupo de alternativas al sistema. gen es el nombre genérico del enlace maestro, enlace es el nombre del enlace simbólico en el directorio de alternativas, y alt es la la alternativa que se va a introducir para el enlace maestro. sgen, senlace y salt son el nombre genérico, el enlace simbólico en el directorio de alternativas y la alternativa para el enlace esclavo. Pueden especificarse cero o más opciones del tipo --slave seguidas de sus argumentos.

    Si el enlace simbólico maestro especificado ya existe en los registros del sistema de alternativas, la información suministrada se añadirá como un nuevo conjunto de alternativas para el grupo. En caso contrario se creará un grupo nuevo, en modo automático, al que se le añadirá la información suministrada. Si el grupo está en modo automático, y la prioridad nueva añadida es mayor que cualquier otra alternativa instalada para ese grupo, los enlaces se actualizarán para apuntar a las nuevas alternativas.

--set nombre camino
    Establece el programa camino como alternativa para nombre. Es equivalente a --config pero de forma no interactiva, de modo que permite su inclusión en scripts.

--remove nombre camino
    Borra una alternativa y todos sus enlaces esclavos asociados. nombre es el nombre en el directorio de alternativas, y camino es el nombre absoluto del fichero al que se podría enlazar nombre . Si nombre está en realidad enlazado a camino, nombre se actualizará para que apunte a otra alternativa apropiada, o será eliminado si no queda ninguna alternativa restante. Los enlaces esclavos asociados serán actualizados o eliminados correspondientemente. Si el enlace está apuntando en ese momento a camino, no se cambia ningún enlace, sólo se elimina la información acerca de la alternativa.

fB--remove-all nombre
    Elimina todas las alternativas y todos sus enlaces esclavos asociados. nombre es un nombre en el directorio de alternativas.

--all
    Llama a --config sobre todas las alternativas.

--auto enlace
    Cambia el enlace simbólico maestro enlace a modo automático. En el proceso, este enlace simbólico y sus esclavos serán actualizados para apuntar a la alternativa instalada con una prioridad mayor.

--display enlace
    Muestra información acerca del grupo de enlaces del cual enlace es el enlace maestro. La información mostrada incluye el modo del grupo (automático o manual), a que alternativa apunta el enlace simbólico, otras alternativas disponibles (y sus alternativas esclavas correspondientes), y la prioridad más alta instalada actualmente.

--list enlace
    Muestra todos objetivos de un grupo de enlaces.

--config enlace
    Muestra las alternativas disponibles para un grupo de enlaces y permite a un usuario seleccionar interactivamente cual usar. El grupo de enlaces se actualiza y se deshabilita el modo auto en él.

FICHEROS

/etc/alternatives/
    El directorio de alternativas por omisión. Puede ser cambiado con la opción --altdir .

/var/lib/dpkg/alternatives/
    El directorio de administración por omisión. Puede ser modificado con la opción --admindir .

ESTADO DE SALIDA

0   La acción requerida fue realizada con éxito.

2   Se encontraron problemas interpretando la línea de órdenes o realizando la acción requerida.

DIAGNÓSTICOS
update-alternatives informa innecesariamente acerca de sus actividades en la salida estándar. Si ocurre algún problema update-alternatives canaliza los mensajes de error a la salida de errores estándar y devuelve un estado de salida de 2. Los diagnósticos deberían ser auto-explicativos, si a usted no se lo parecen, por favor, avise de esto como un fallo.

FALLOS
Si encuentra algún fallo, por favor, avise usando el sistema de seguimiento de fallos de Debian, o, si esto no es posible, mande un email directamente al autor.

Si encuentra alguna discrepancia entre el modo de operación de update-alternatives y esta página del manual, es un fallo, bien en la implementación o bien en la documentación, por favor, avise.

AUTOR
Update-alternatives de Debian es copyright 1995 de Ian Jackson. Es un programa libre, vea la licencia GPL de GNU versión 2 o posterior para las condiciones de copia. NO hay ninguna garantía.

Esta página del manual es copyright 1997/98 de Charles Briscoe-Smith. Es documentación libre, vea la licencia GPL de GNU versión 2 o posterior para las condiciones de copia. NO hay ninguna garantía.

Puede encontrar la licencia GPL de GNU en /usr/share/common-licenses/GPL en cualquier sistema Debian.

Traducida por Rubén Porras <nahoo@inicia.es>, revisada por Santiago Vila <sanvila@unex.es> y Javier Fernández-Sanguino.

VEA ADEMÁS
ln(1), FHS, el estándar sobre la jerarquía del sistema de ficheros.